Index: c/src/lib/libbsp/arm/altera-cyclone-v/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/altera-cyclone-v/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/altera-cyclone-v/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -152,4 +152,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
 libbsp_a_SOURCES += ../../shared/bsppredriverhook.c
Index: c/src/lib/libbsp/arm/atsam/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/atsam/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/atsam/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -333,4 +333,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/arm/beagle/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/beagle/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/beagle/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -77,4 +77,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/src/bsp-fdt.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
Index: c/src/lib/libbsp/arm/csb336/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/csb336/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/csb336/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -34,4 +34,5 @@
     ../../shared/bsppredriverhook.c startup/bspstart.c ../../shared/bspclean.c \
     ../../shared/bspreset.c startup/memmap.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/gnatinstallhandler.c
 libbsp_a_SOURCES += ../../shared/cpucounterread.c
Index: c/src/lib/libbsp/arm/csb337/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/csb337/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/csb337/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -57,4 +57,5 @@
     ../../shared/bspclean.c startup/bspreset.c \
     startup/memmap.c ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/gnatinstallhandler.c
 libbsp_a_SOURCES += ../../shared/cpucounterread.c
Index: c/src/lib/libbsp/arm/edb7312/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/edb7312/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/edb7312/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -35,4 +35,5 @@
     ../../shared/bsppredriverhook.c startup/bspstart.c \
     ../../shared/bspclean.c ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/getentropy-cpucounter.c \
     startup/bspreset.c ../../shared/gnatinstallhandler.c
 libbsp_a_SOURCES += ../../shared/cpucounterread.c
Index: c/src/lib/libbsp/arm/gdbarmsim/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/gdbarmsim/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/gdbarmsim/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -37,4 +37,5 @@
     ../../shared/bsppredriverhook.c ../../shared/bspstart.c \
     ../../shared/bspclean.c startup/bspreset.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/gnatinstallhandler.c startup/syscalls.c
 libbsp_a_SOURCES += ../../shared/cpucounterread.c
Index: c/src/lib/libbsp/arm/gumstix/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/gumstix/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/gumstix/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -32,4 +32,5 @@
   ../../shared/bsppredriverhook.c ../../shared/bspgetworkarea.c \
   ../../shared/bootcard.c ../../shared/sbrk.c \
+  ../../shared/getentropy-cpucounter.c \
   ../../shared/gnatinstallhandler.c \
   ../../shared/bspclean.c startup/bspstart.c startup/bspreset.c startup/memmap.c
Index: c/src/lib/libbsp/arm/lm3s69xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/lm3s69xx/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/lm3s69xx/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -62,4 +62,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/arm/lpc176x/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/lpc176x/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/lpc176x/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -91,4 +91,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/arm/lpc24xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/lpc24xx/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/lpc24xx/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -93,4 +93,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c \
+	../../shared/getentropy-cpucounter.c \
 	../../shared/bspclean.c \
 	../../shared/bspgetworkarea.c \
Index: c/src/lib/libbsp/arm/lpc32xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/lpc32xx/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/lpc32xx/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -85,4 +85,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/arm/raspberrypi/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/raspberrypi/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/raspberrypi/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -83,4 +83,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bsppredriverhook.c
Index: c/src/lib/libbsp/arm/realview-pbx-a9/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/realview-pbx-a9/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/realview-pbx-a9/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -80,4 +80,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/arm/rtl22xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/rtl22xx/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/rtl22xx/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -36,4 +36,5 @@
     ../../shared/bspclean.c startup/bspreset.c \
     ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/gnatinstallhandler.c
 libbsp_a_SOURCES += ../../shared/cpucounterread.c
Index: c/src/lib/libbsp/arm/smdk2410/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/smdk2410/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/smdk2410/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -35,4 +35,5 @@
 libbsp_a_SOURCES += startup/memmap.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 
Index: c/src/lib/libbsp/arm/stm32f4/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/stm32f4/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/stm32f4/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -77,4 +77,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/arm/tms570/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/tms570/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/tms570/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -119,4 +119,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/arm/xilinx-zynq/Makefile.am
===================================================================
--- c/src/lib/libbsp/arm/xilinx-zynq/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/arm/xilinx-zynq/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -77,4 +77,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/bfin/TLL6527M/Makefile.am
===================================================================
--- c/src/lib/libbsp/bfin/TLL6527M/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/bfin/TLL6527M/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -31,4 +31,5 @@
 	../../shared/bspclean.c ../../shared/sbrk.c ../../shared/setvec.c \
 	../../shared/bootcard.c ../../shared/gnatinstallhandler.c \
+	../../shared/getentropy-cpucounter.c \
 	../../shared/bspgetworkarea.c
 
Index: c/src/lib/libbsp/bfin/bf537Stamp/Makefile.am
===================================================================
--- c/src/lib/libbsp/bfin/bf537Stamp/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/bfin/bf537Stamp/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -31,4 +31,5 @@
 	../../shared/bspclean.c ../../shared/sbrk.c ../../shared/setvec.c \
 	../../shared/bootcard.c ../../shared/gnatinstallhandler.c \
+	../../shared/getentropy-cpucounter.c \
 	../../shared/bspgetworkarea.c
 
Index: c/src/lib/libbsp/bfin/eZKit533/Makefile.am
===================================================================
--- c/src/lib/libbsp/bfin/eZKit533/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/bfin/eZKit533/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -32,4 +32,5 @@
 	../../shared/bspclean.c ../../shared/sbrk.c ../../shared/setvec.c \
 	../../shared/bootcard.c ../../shared/gnatinstallhandler.c \
+	../../shared/getentropy-cpucounter.c \
 	../../shared/bspgetworkarea.c
 
Index: c/src/lib/libbsp/epiphany/epiphany_sim/Makefile.am
===================================================================
--- c/src/lib/libbsp/epiphany/epiphany_sim/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/epiphany/epiphany_sim/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -57,4 +57,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bsppredriverhook.c
Index: c/src/lib/libbsp/i386/pc386/Makefile.am
===================================================================
--- c/src/lib/libbsp/i386/pc386/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/i386/pc386/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -157,4 +157,5 @@
 libbsp_a_SOURCES += ../../i386/shared/irq/elcr.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += startup/ldsegs.S
Index: c/src/lib/libbsp/lm32/lm32_evr/Makefile.am
===================================================================
--- c/src/lib/libbsp/lm32/lm32_evr/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/lm32/lm32_evr/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -34,4 +34,5 @@
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += ../../shared/setvec.c
Index: c/src/lib/libbsp/lm32/milkymist/Makefile.am
===================================================================
--- c/src/lib/libbsp/lm32/milkymist/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/lm32/milkymist/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -50,4 +50,5 @@
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/m32c/m32cbsp/Makefile.am
===================================================================
--- c/src/lib/libbsp/m32c/m32cbsp/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m32c/m32cbsp/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -30,4 +30,5 @@
     ../../shared/bspgetworkarea.c \
     startup/bspstart.c ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/gnatinstallhandler.c startup/crtn.S
 clock_SOURCES = ../../shared/clock_driver_simidle.c
Index: c/src/lib/libbsp/m68k/av5282/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/av5282/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/av5282/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -32,4 +32,5 @@
     startup/init5282.c startup/bspstart.c \
     ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/setvec.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/m68k/csb360/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/csb360/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/csb360/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -33,4 +33,5 @@
     ../../shared/bspgetworkarea.c \
     ../../shared/bspstart.c startup/init5272.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/setvec.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/m68k/gen68340/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68340/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/gen68340/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -36,4 +36,5 @@
     ../../shared/bspstart.c startup/init68340.c \
     ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/setvec.c \
     startup/dumpanic.c ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/m68k/gen68360/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/gen68360/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/gen68360/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -31,4 +31,5 @@
     ../../shared/bspgetworkarea.c ../../shared/bspstart.c \
     startup/init68360.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/setvec.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/m68k/genmcf548x/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/genmcf548x/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/genmcf548x/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -42,4 +42,5 @@
   ../../shared/bsppredriverhook.c startup/init548x.c startup/bspstart.c \
   ../../shared/bootcard.c ../../shared/sbrk.c ../../shared/setvec.c \
+  ../../shared/getentropy-cpucounter.c \
   ../../shared/gnatinstallhandler.c
 # clock
Index: c/src/lib/libbsp/m68k/mcf5206elite/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5206elite/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/mcf5206elite/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -38,4 +38,5 @@
     ../../shared/bsppredriverhook.c ../../shared/bspgetworkarea.c \
     ../../shared/bspstart.c startup/init5206e.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/setvec.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/m68k/mcf52235/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf52235/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/mcf52235/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -32,4 +32,5 @@
     startup/init52235.c ../../shared/bspstart.c startup/cfinit.c \
     startup/bspgetcpuclockspeed.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/setvec.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/m68k/mcf5225x/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5225x/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/mcf5225x/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -31,4 +31,5 @@
     startup/init5225x.c startup/bspstart.c \
     ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/setvec.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/m68k/mcf5235/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5235/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/mcf5235/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -33,4 +33,5 @@
     ../../shared/bspgetworkarea.c startup/init5235.c startup/bspstart.c \
     ../../shared/bootcard.c ../../shared/sbrk.c ../../shared/setvec.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/gnatinstallhandler.c \
     startup/copyvectors.c
Index: c/src/lib/libbsp/m68k/mcf5329/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mcf5329/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/mcf5329/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -32,4 +32,5 @@
     startup/init5329.c startup/bspstart.c startup/cfinit.c\
     ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/setvec.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/m68k/mrm332/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mrm332/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/mrm332/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -32,4 +32,5 @@
     ../../shared/bspstart.c startup/bsppredriverhook.c \
     ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/bspclean.c \
     ../../shared/setvec.c \
Index: c/src/lib/libbsp/m68k/mvme147/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme147/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/mvme147/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -33,4 +33,5 @@
 libbsp_a_SOURCES += startup/bspclean.c \
     startup/bspstart.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/bsppredriverhook.c \
     ../../shared/bspgetworkarea.c ../../shared/sbrk.c \
Index: c/src/lib/libbsp/m68k/mvme147s/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme147s/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/mvme147s/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -34,4 +34,5 @@
     ../../shared/bsppredriverhook.c \
     startup/bspstart.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/setvec.c \
     ../../shared/bspgetworkarea.c ../../shared/setvec.c \
Index: c/src/lib/libbsp/m68k/mvme162/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/mvme162/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -37,4 +37,5 @@
     ../../shared/bsppredriverhook.c \
     startup/bspstart.c ../../shared/bootcard.c  \
+    ../../shared/getentropy-cpucounter.c \
     startup/page_table.c \
     ../../shared/bspgetworkarea.c startup/page_table.c \
Index: c/src/lib/libbsp/m68k/mvme167/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme167/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/mvme167/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -34,4 +34,5 @@
     ../../shared/bspgetworkarea.c \
     startup/bspstart.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     startup/page_table.c \
     ../../shared/sbrk.c ../../shared/setvec.c \
Index: c/src/lib/libbsp/m68k/uC5282/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/uC5282/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/m68k/uC5282/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -31,4 +31,5 @@
     ../../shared/bspgetworkarea.c \
     startup/init5282.c startup/bspstart.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/setvec.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/mips/csb350/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/csb350/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/mips/csb350/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -39,4 +39,5 @@
 libbsp_a_SOURCES += startup/bspstart.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 # clock
Index: c/src/lib/libbsp/mips/hurricane/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/hurricane/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/mips/hurricane/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -37,4 +37,5 @@
 libbsp_a_SOURCES += startup/bspstart.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += startup/inittlb.c
Index: c/src/lib/libbsp/mips/jmr3904/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/jmr3904/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/mips/jmr3904/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -37,4 +37,5 @@
 libbsp_a_SOURCES += startup/bspstart.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 # clock
Index: c/src/lib/libbsp/mips/malta/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/malta/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/mips/malta/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -44,4 +44,5 @@
 libbsp_a_SOURCES += startup/bspreset.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += startup/inittlb.c
Index: c/src/lib/libbsp/mips/rbtx4925/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/rbtx4925/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/mips/rbtx4925/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -38,4 +38,5 @@
 libbsp_a_SOURCES += startup/bspstart.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += startup/inittlb.c
Index: c/src/lib/libbsp/mips/rbtx4938/Makefile.am
===================================================================
--- c/src/lib/libbsp/mips/rbtx4938/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/mips/rbtx4938/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -38,4 +38,5 @@
 libbsp_a_SOURCES += startup/bspstart.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += startup/inittlb.c
Index: c/src/lib/libbsp/moxie/moxiesim/Makefile.am
===================================================================
--- c/src/lib/libbsp/moxie/moxiesim/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/moxie/moxiesim/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -35,4 +35,5 @@
     ../../shared/bspgetworkarea.c \
     ../../shared/bspstart.c ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/gnatinstallhandler.c
 # clock
Index: c/src/lib/libbsp/nios2/nios2_iss/Makefile.am
===================================================================
--- c/src/lib/libbsp/nios2/nios2_iss/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/nios2/nios2_iss/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -35,4 +35,5 @@
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += startup/setvec.c
Index: c/src/lib/libbsp/no_cpu/no_bsp/Makefile.am
===================================================================
--- c/src/lib/libbsp/no_cpu/no_bsp/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/no_cpu/no_bsp/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -28,4 +28,5 @@
     ../../shared/startup/bspgetworkarea.c \
     startup/bspstart.c ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/getentropy-cpucounter.c \
     startup/setvec.c ../../shared/gnatinstallhandler.c
 # clock
Index: c/src/lib/libbsp/or1k/generic_or1k/Makefile.am
===================================================================
--- c/src/lib/libbsp/or1k/generic_or1k/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/or1k/generic_or1k/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -67,4 +67,5 @@
 # Shared
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/powerpc/beatnik/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/beatnik/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/beatnik/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -67,4 +67,5 @@
     ../../powerpc/shared/startup/pgtbl_activate.c \
     ../../powerpc/shared/startup/sbrk.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     startup/bspclean.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/powerpc/gen5200/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/gen5200/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/gen5200/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -131,4 +131,5 @@
 # startup
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/powerpc/gen83xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/gen83xx/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/gen83xx/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -54,4 +54,5 @@
 libbsp_a_SOURCES += \
 	../../shared/bootcard.c \
+	../../shared/getentropy-cpucounter.c \
 	../../shared/bsppredriverhook.c \
 	../../shared/sbrk.c \
Index: c/src/lib/libbsp/powerpc/haleakala/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/haleakala/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/haleakala/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -30,4 +30,5 @@
     ../../shared/bspreset_loop.c \
     startup/bspstart.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/bsppredriverhook.c ../../shared/bspgetworkarea.c \
     ../../shared/sbrk.c \
Index: c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/motorola_powerpc/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -50,4 +50,5 @@
 	../../powerpc/shared/startup/ppc_idle.c \
     ../../powerpc/shared/startup/sbrk.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/bspclean.c \
     ../../shared/gnatinstallhandler.c \
Index: c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/mpc55xxevb/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -64,4 +64,5 @@
 # startup
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
 libbsp_a_SOURCES += ../../shared/bsppredriverhook.c
Index: c/src/lib/libbsp/powerpc/mpc8260ads/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mpc8260ads/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/mpc8260ads/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -53,4 +53,5 @@
     ../../shared/bsppredriverhook.c \
     ../shared/startup/bspidle.c startup/bspstart.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/gnatinstallhandler.c startup/cpuinit.c \
     ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/powerpc/mvme3100/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mvme3100/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/mvme3100/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -55,4 +55,5 @@
     ../../powerpc/shared/startup/zerobss.c \
     ../../powerpc/shared/startup/sbrk.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/bspclean.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/powerpc/mvme5500/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/mvme5500/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/mvme5500/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -34,4 +34,5 @@
     ../../powerpc/shared/startup/bspgetworkarea.c \
     ../../powerpc/shared/startup/sbrk.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     startup/bspclean.c \
     ../../shared/gnatinstallhandler.c startup/bspreset.c \
Index: c/src/lib/libbsp/powerpc/psim/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/psim/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/psim/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -37,4 +37,5 @@
     ../../shared/bsppredriverhook.c startup/bspstart.c \
     ../../shared/bspgetworkarea.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../powerpc/shared/startup/sbrk.c ../../shared/gnatinstallhandler.c
 
Index: c/src/lib/libbsp/powerpc/qemuppc/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/qemuppc/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/qemuppc/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -33,4 +33,5 @@
     ../../shared/bspgetworkarea.c \
     ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/gnatinstallhandler.c \
     startup/cmain.c startup/bspstart.c startup/bsppanic.c
Index: c/src/lib/libbsp/powerpc/qoriq/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/qoriq/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/qoriq/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -66,4 +66,5 @@
 libbsp_a_SOURCES += \
 	../../shared/bootcard.c \
+	../../shared/getentropy-cpucounter.c \
 	../../shared/sbrk.c \
 	../../shared/gnatinstallhandler.c \
Index: c/src/lib/libbsp/powerpc/ss555/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/ss555/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/ss555/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -37,4 +37,5 @@
     ../../shared/bsppredriverhook.c \
     startup/bspstart.c ../../shared/bootcard.c startup/iss555.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/sbrk.c ../../shared/gnatinstallhandler.c start/start.S \
     ../../shared/bspgetworkarea.c
Index: c/src/lib/libbsp/powerpc/t32mppc/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/t32mppc/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/t32mppc/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -45,4 +45,5 @@
 libbsp_a_SOURCES += \
 	../../shared/bootcard.c \
+	../../shared/getentropy-cpucounter.c \
 	../../shared/bsppredriverhook.c \
 	../../shared/sbrk.c \
Index: c/src/lib/libbsp/powerpc/tqm8xx/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/tqm8xx/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/tqm8xx/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -63,4 +63,5 @@
     ../shared/startup/bspidle.c \
     startup/bspstart.c startup/bspgetworkarea.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     startup/mmutlbtab.c startup/cpuinit.c ../../shared/sbrk.c \
     ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/powerpc/virtex/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/virtex/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/virtex/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -46,4 +46,5 @@
     ../../shared/bspreset_loop.c \
     startup/bspstart.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/bsppredriverhook.c \
     ../../shared/sbrk.c ../../shared/gnatinstallhandler.c
Index: c/src/lib/libbsp/powerpc/virtex4/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/virtex4/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/virtex4/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -34,4 +34,5 @@
                    startup/bspstart.c \
                    ../../shared/bootcard.c \
+                   ../../shared/getentropy-cpucounter.c \
                    ../../shared/sbrk.c \
                    ../../shared/gnatinstallhandler.c \
Index: c/src/lib/libbsp/powerpc/virtex5/Makefile.am
===================================================================
--- c/src/lib/libbsp/powerpc/virtex5/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/powerpc/virtex5/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -33,4 +33,5 @@
                    startup/bspstart.c \
                    ../../shared/bootcard.c \
+                   ../../shared/getentropy-cpucounter.c \
                    ../../shared/sbrk.c \
                    ../../shared/gnatinstallhandler.c \
Index: c/src/lib/libbsp/sh/gensh1/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/gensh1/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/sh/gensh1/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -38,4 +38,5 @@
     ../../shared/bspgetworkarea.c \
     ../../shared/sbrk.c ../../shared/bootcard.c ../shared/bsphwinit.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/gnatinstallhandler.c
 # scitab
Index: c/src/lib/libbsp/sh/gensh2/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/gensh2/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/sh/gensh2/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -39,4 +39,5 @@
     ../shared/startup/bspstart.c \
     ../../shared/bspgetworkarea.c ../../shared/sbrk.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/gnatinstallhandler.c ../../shared/bspclean.c \
     ../shared/bsphwinit.c
Index: c/src/lib/libbsp/sh/gensh4/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/gensh4/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/sh/gensh4/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -32,4 +32,5 @@
     ../../shared/bspgetworkarea.c \
     ../../shared/bspclean.c ../../shared/sbrk.c ../../shared/bootcard.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/gnatinstallhandler.c ../shared/bsphwinit.c
 # console
Index: c/src/lib/libbsp/sh/shsim/Makefile.am
===================================================================
--- c/src/lib/libbsp/sh/shsim/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/sh/shsim/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -33,5 +33,7 @@
 libbsp_a_SOURCES += ../../shared/bspgetworkarea.c
 libbsp_a_SOURCES += ../../shared/bspclean.c
-libbsp_a_SOURCES += ../../shared/sbrk.c ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/sbrk.c
+libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/gnatinstallhandler.c
 libbsp_a_SOURCES += ../shared/bsphwinit.c
Index: c/src/lib/libbsp/shared/getentropy-cpucounter.c
===================================================================
--- c/src/lib/libbsp/shared/getentropy-cpucounter.c	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
+++ c/src/lib/libbsp/shared/getentropy-cpucounter.c	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2017 embedded brains GmbH.  All rights reserved.
+ *
+ *  embedded brains GmbH
+ *  Dornierstr. 4
+ *  82178 Puchheim
+ *  Germany
+ *  <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ */
+
+/*
+ * ATTENTION: THIS IS A VERY LIMITED ENTROPY SOURCE.
+ *
+ * This implementation uses a time-based value for it's entropy. The only thing
+ * that makes it random are interrupts from external sources. Don't use it if
+ * you need for example a strong crypto.
+ */
+
+#include <unistd.h>
+#include <string.h>
+#include <rtems/sysinit.h>
+#include <rtems/counter.h>
+
+int getentropy(void *ptr, size_t n)
+{
+	uint8_t *dest = ptr;
+
+	while (n > 0) {
+		rtems_counter_ticks ticks;
+
+		ticks = rtems_counter_read();
+
+		if (n >= sizeof(ticks)) {
+			memcpy(dest, &ticks, sizeof(ticks));
+			n -= sizeof(ticks);
+			dest += sizeof(ticks);
+		} else {
+			/*
+			 * Fill the remaining bytes with only the least
+			 * significant byte of the time. That is the byte with
+			 * the most changes.
+			 */
+			*dest = ticks & 0xFF;
+			--n;
+			++dest;
+		}
+	}
+
+	return 0;
+}
Index: c/src/lib/libbsp/sparc/erc32/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc/erc32/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/sparc/erc32/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -34,4 +34,5 @@
 libbsp_a_SOURCES += ../../shared/bspstart.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += startup/setvec.c
Index: c/src/lib/libbsp/sparc/leon2/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc/leon2/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/sparc/leon2/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -38,4 +38,5 @@
 libbsp_a_SOURCES += ../../sparc/shared/startup/bspgetworkarea.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += startup/setvec.c
Index: c/src/lib/libbsp/sparc/leon3/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc/leon3/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/sparc/leon3/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -39,4 +39,5 @@
 libbsp_a_SOURCES += \
     ../../shared/bootcard.c startup/bspstart.c \
+    ../../shared/getentropy-cpucounter.c \
     startup/bsppredriver.c \
     ../../sparc/shared/startup/bspgetworkarea.c ../../shared/sbrk.c \
Index: c/src/lib/libbsp/sparc64/niagara/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc64/niagara/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/sparc64/niagara/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -42,4 +42,5 @@
     ../../shared/bsppredriverhook.c \
     ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/bspgetworkarea.c \
     ../../shared/bspstart.c \
Index: c/src/lib/libbsp/sparc64/usiii/Makefile.am
===================================================================
--- c/src/lib/libbsp/sparc64/usiii/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/sparc64/usiii/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -88,4 +88,5 @@
     ../../shared/bspstart.c \
     ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/getentropy-cpucounter.c \
     ../../shared/bspgetworkarea.c \
     ../../shared/bsppredriverhook.c \
Index: c/src/lib/libbsp/v850/gdbv850sim/Makefile.am
===================================================================
--- c/src/lib/libbsp/v850/gdbv850sim/Makefile.am	(revision ddc339c51fa436e91eba083029bec3849997899e)
+++ c/src/lib/libbsp/v850/gdbv850sim/Makefile.am	(revision ca4895cb9cbaa48f16e63fff8b1d12a32d840026)
@@ -35,4 +35,5 @@
 libbsp_a_SOURCES += ../../shared/bspstart.c
 libbsp_a_SOURCES += ../../shared/bootcard.c
+libbsp_a_SOURCES += ../../shared/getentropy-cpucounter.c
 libbsp_a_SOURCES += ../../shared/sbrk.c
 libbsp_a_SOURCES += ../../shared/gnatinstallhandler.c
